#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>
#include <sys/time.h>
#include <unistd.h>

#include "util.h"

int mem_load(FILE *fp, uint8_t *buf, int bufsiz) {
	uint8_t  *p = (void *)buf;
	int x;
	int len;
	uint8_t line[256];

	memset(buf, 0, bufsiz);

	while (fgets(line, 256, fp)) {
		len = strlen(line);
		if (line[len-1] == '\n') len--;
		if (line[len-1] == '\r') len--;
		line[len] = 0;
		if (len == 4 ) {
			if (sscanf(line,"%x",&x)) {
				p[0] = x & 0xff;
				p[1] = (x >> 8) & 0xff;
				if ((p - buf) + 3 < bufsiz) p += 2;
			}
		}
	}
	if ((p - buf) & 0x7ff) return -1;
	return (p - buf);
}

#ifdef STANDALONE_TEST

main(int argc, char *argv[]) {
	FILE *fp;
	int r;
	uint8_t *buf;

	build_rev();
	fp = fopen(argv[1],"rb");
	if (fp == NULL) exit(1);
	buf = malloc(1024 * 1024 * 2);
	r = mem_load(fp, buf, 1024 * 1024 * 2);
	printf("size %d\n", r);
	dump(buf, 0x0000, (r>0)? r : 256, 0);
}
#endif
